//=======================================================================
// postfixe.cc : valuation d'une expression en notation postfixe
// Copyright (C) 2004-2006 by Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//
//  compiler avec  g++ postfixe.cc -o postfixe -lgmpxx
//=======================================================================

#include <iostream>           // dclarer l'entre-sortie standard
#include <sstream>            // conversion entre string et flot
#include "eval-postfixe.cc"   // evaluation en notation postfixe
using namespace std;          // accs direct aux fonctions standard

int main( int nombre, char* arguments[] )
{
  // Message de bienvenue
  clog << "valuation d'une expression en notation postfixe" << endl;
  
  // valuer le flot d'entre standard
  if ( nombre == 1 )
    {
      clog << "Lecture du flot d'entre standard..." << endl;
      Integer resultat= eval_postfixe( cin, clog );
      cout << resultat << endl;
      if ( cin.good() ) return 0; else return 1; /* erreur */
    }

  // valuer l'argument donn par la ligne de commande
  if ( nombre == 2 )
    {
      clog << "Lecture de l'argument donn par la ligne de commande..." << endl;
      istringstream iss( arguments[1] );
      Integer resultat= eval_postfixe( iss, clog );
      cout << resultat << endl;
      if ( iss.good() ) return 0; else return 1; /* erreur */
    }

  // Afficher l'aide en ligne
  clog << "Usage : postfixe [<expression>]" << endl;
}

