void Permut::getCycles( Cycles& cycles ) const
{ 
  // Le vecteur suivant indique les points dj visits
  vector<bool> deja_visite( degre(), false );
  
  // Visiter tous les points et parcourir chaque cycle exactement une fois
  cycles.clear();
  for ( Point i=0; i<degre(); ++i )
    {
      // On ne tient compte que des cycles de longueur > 1
      // et on vite bien sr les cycles dj parcourus.
      if ( leVecteur[i]!=i && !deja_visite[i] )
	{
	  // Parcourir ce cycle en visitant ses points un par un
	  Cycle leCycle;
	  leCycle.push_back( i );
	  deja_visite[i]= true;
	  for( Point j= leVecteur[i]; !deja_visite[j]; j= leVecteur[j] )
	    {
	      leCycle.push_back( j );
	      deja_visite[j]= true;
	    };
	  // Ajouter ce cycle  la liste des cycles dj construite
	  cycles.push_back( leCycle );
	};
    };
  // Commes les cycles disjoints commutent, la dcomposition n'est unique
  // qu' l'ordre prs. On prfre ici les trier en longueurs croissantes.
  sort( cycles.begin(), cycles.end() );
};
