template <typename Anneau>
class Fraction
{
private:
  Anneau numer, denom;   // numrateur et dnominateur
  void normaliser(void)  // normaliser numer/denom
    { if ( zero(denom) ) { cerr << "Division par zro !\n"; exit(1); };
      Anneau d= pgcd(numer,denom); 
      divisible(numer,d,numer); divisible(denom,d,denom);
      Anneau u; denom= assopref(denom,u); numer*= u; }; 
 
public:
  // Constructeurs divers
  Fraction( int num=0, int den=1 )
    : numer(num), denom(den) { normaliser(); }
  Fraction( const Anneau& num, const Anneau& den )
    : numer(num), denom(den) { normaliser(); };
  Fraction( const Fraction& a )
    : numer(a.numer), denom(a.denom) {};

  // Affectation
  void affecter( int num=0, int den=1 )
    { numer= num; denom= den; normaliser(); };
  void affecter( const Anneau& num, const Anneau& den )
    { numer= num; denom= den; normaliser(); };
  Fraction& operator= ( const Fraction& a )
    { numer= a.numer; denom= a.denom; return *this; };

  // Lire le numrateur et le dnominateur
  const Anneau& numerateur() const { return numer; };
  const Anneau& denominateur() const { return denom; };
  
  // Comparaison
  bool operator== ( const Fraction& a ) const
    { return ( numer*a.denom == denom*a.numer ); };
  bool operator!= ( const Fraction& a ) const
    { return ( numer*a.denom != denom*a.numer ); };

  // Addition
  Fraction operator+ ( const Fraction& a ) const
    { return Fraction( numer*a.denom + denom*a.numer, denom*a.denom ); };
  Fraction& operator+= ( const Fraction& a )
    { affecter( numer*a.denom + denom*a.numer, denom*a.denom ); return *this; };

  // Oppos et soustraction
  Fraction operator- () const
    { return Fraction( -numer, denom ); };
  Fraction operator- ( const Fraction& a ) const
    { return Fraction( numer*a.denom - denom*a.numer, denom*a.denom ); };
  Fraction& operator-= ( const Fraction& a )
    { affecter( numer*a.denom - denom*a.numer, denom*a.denom ); return *this; };

  // Multiplication (correcte mais non optimise)
  Fraction operator* ( const Fraction& a ) const
    { return Fraction( numer*a.numer, denom*a.denom ); };
  Fraction& operator*= ( const Fraction& a )
    { affecter( numer*a.numer, denom*a.denom ); return *this; };

  // Division (correcte mais non optimise)
  Fraction operator/ ( const Fraction& a ) const
    { return Fraction( numer*a.denom, denom*a.numer ); };
  Fraction& operator/= ( const Fraction& a )
    { affecter( numer*a.denom, denom*a.numer ); return *this; };
};
