//=======================================================================
// pecoprem.cc : classe pour modliser les petits corps premiers
// Copyright (C) 2004-2007 by Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//=======================================================================

#include <iostream>
#include "pecoprem.hh"
using namespace std;

const int p= 11;

void test( GF<p> a, GF<p> b )
{
  cout << "a = " << a << endl;
  cout << "b = " << b << endl;
  cout << "a+b = " << a+b << endl;
  cout << "-b = " << -b << endl;
  cout << "a-b = " << a-b << endl;
  cout << "a*b = " << a*b << endl;
  cout << "1/b = " << 1/b << endl;
  cout << "a/b = " << a/b << endl;
  cout << endl;
}

int main()
{
  cout << "\nBonjour et bienvenue aux petits corps premiers.\n"
       << "Le calcule suivant se place dans GF<" << p << ">.\n" << endl;
  GF<p> a=3, b=-2;
  test(a,b);
  ++a;
  --b;
  test(a,b);
}
