//=======================================================================
// exp.cc : implmentation nave de l'exponentielle exp(x)
// Copyright (C) 2006-2007 Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//
// Description :
// La fonction exp est dfinie par exp(x) = 1 + x + x/2 + x/6 + ...  
// et cette srie converge pour tout x.  Numriquement, par contre,
// l'valuation peut poser de graves problmes si l'on s'y prend 
// navement.  Pour |x| grand les premiers termes x^k/k! croissent 
// avant que la factorielle ne l'emporte.  Si de plus x est ngatif
// tout le calcul est victime d'une invitable cancellation.  
//=======================================================================
#include <iostream>
#include <cmath>
using namespace std;

int main()
{
  cout << "\nBienvenue au calcul naf de la fonction exp(x) avec le type double.\n"
       << "L'valuation se passe bien pour x positif, mais choue pour x ngatif.\n" 
       << "Le tester pour x=10,20,30,... et x=-10,-20,-30,... puis expliquer le problme.\n";

  cout << "Entrez x svp : ";
  double x; 
  cin >> x;

  cout << "Pour approcher la srie  exp(x) = 1 + x + x/2 + x/6 + ...\n"
       << "veuillez choisir un rang n jusqu'auquel je vais sommer : ";
  int n;
  cin >> n;

  // valuation de  1 + x + x/2 + x/6 + ... + x^n/n!  par Horner
  // donc  (((...( x/n + 1 )...) * x/3 + 1 ) * x/2 + 1 ) * x/1 + 1
  double valeur= 1;
  for ( long k=n; k>=1; --k )
    valeur= valeur * x/k + 1;
  
  cout.precision(16);
  cout << "valeur exp(x) calcule : " << valeur << endl;
  cout << "cmath pour comparaison : " << exp(x) << endl; 
  cout << "Au revoir.\n" << endl;
}
