//=======================================================================
// fibonacci.cc : calcul numrique de suites de fibonacci
// Copyright (C) 2006-2007 Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//
// Description :
// On considre ici les suites de Fibonacci, c'est--dire
// des suites rcurrentes de la forme  x[n+2] = x[n+1] + x[n+1].  
// Pour ceci on se fixe les deux valeurs initiales x[0] et x[1] 
// puis on calcule les valeurs succesives.  
//=======================================================================

#include <iostream>
#include <iomanip>
#include <string>
#include <cmath> 
using namespace std;

void wait_for_return()
{
  // Attendre la touche RETURN (ENTREE)
  string s;
  getline(cin,s);
}

int main()
{
  cout << "\nBienvenue aux suites de Fibonacci,  x[n+2] = x[n] + x[n+1].\n"
       << "Entrez les deux valeurs initiales, par exemple  x0 = 1.0  et  x1 = 1.0,\n"
       << "ou  x0 = 1.0  et  x1 = (1-sqrt(5))/2 ~ -0.6180339887498949...\n" << endl;
  double x0, x1;
  cout << "x0 = ";
  cin >> x0;
  cout << "x1 = ";
  cin >> x1;

  // double x0= 1.0;
  // double x1= ( 1.0 - sqrt(5.0) ) / 2.0;

  // Afficher les deux valeurs initiales de manire bien formate
  cout.precision(16);
  cout.setf( ios::fixed | ios::showpoint );
  cout << "Valeurs de la suite :\n"
       << "x[  0] = " << setw(30) << x0 << endl
       << "x[  1] = " << setw(30) << x1 << endl;
  wait_for_return();
  
  // Boucle pour calculer des valeurs successives
  for( int n=2; n<=200; ++n )
    {
      // Calculer la nouvelle valeur puis dcaler les indices
      double x2= x0 + x1;
      x0= x1;
      x1= x2;

      // Afficher la nouvelle valeur de manire bien formate
      cout << "x[" << setw(3) << n << "] = " 
	   << setw(30) << x2 << "  ";
      wait_for_return();
    }
  cout << "Au revoir &  bientt." << endl;
}
