//=======================================================================
// newton.cc : itration de x -> (x+2/x)/2 de manire exacte et approche
// Copyright (C) 2006-2007 Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//
// Description :
// Ce petit programme illustre le phnomne d'explosion de coefficients
// qui peut rendre le calcul exact infaisable.
//=======================================================================

#include <iostream>
#include <gmpxx.h>
using namespace std;

// On utilise la classe mpq_class de la bibliothque GMP
// pour calculer avec les nombres rationnels (calcul exact).
typedef mpq_class Rationnel;

int main()
{
  cout << "\nBonjour et bienvenue aux calcul de sqrt(3)\n"
       << "par la mthode de Newton (arrondie puis exacte)."<< endl;

  cout << "\nCalcul arrondi en utilisant le type double:" << endl;
  double r= 2.0;
  cout.precision(16);
  for( int k=1; k<=7; ++k )
    {
      r= (r+3/r)/2;
      cout << "k=" << k << "  r=" << r << endl;
    }

  cout << "\nCalcul exact avec des nombres rationnels:" << endl;
  Rationnel q= 2.0;
  for( int k=1; k<=7; ++k )
    {
      q= (q+3/q)/2;
      cout << "k=" << k << "  q=" << q << endl;
    }
}
