//=======================================================================
// somme-interval.cc : sommation de la srie  terme gnral 1/k
// Copyright (C) 2007 Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//
// Compilation :
// Compiler avec l'option -lgmpxx pour intgrer la bibliothque gmp. 
//
// Description :
// Ce petit programme calcule la somme de 1/k pour k=1,...,n puis dans
// le sens inverse k=n,...,1.  Dans les deux cas on tablit un encadrement 
// fiable en utilisant l'arithmtique d'intervalles.  Ainsi on obtient
// deux encadrements corrects, mais l'un est plus fin que l'autre.
// Exercice : expliquer la diffrence, puis formuler une conclusion.
//
// Commentaire :
// Vous trouvez le mme calcul dans le fichier somme-rreal.cc utilisant
// directement le type RReal sans intervalles.  C'est strictement la mme
// dmarche et le mme rsultat, seule l'criture est moins commode.
//=======================================================================

#include <iostream>
using namespace std;

#include "interval.cc"
using namespace Numeric;

int main()
{
  const int max= 10000;
  cout << "\nBonjour et bienvenue ! Je calcule la somme s des termes 1/k^2" << endl
       << "pour k de 1  " << max << " dans le sens croissant puis dcroissant en k." << endl;
  Len decimales= demander_la_precision();
  cout.precision( decimales );

  Interval somme1(0,0);
  for( int k=1; k<=max; ++k ) somme1+= 1 / sqr( Interval(k) );
  cout << "Sommation par indices croissants   : " << somme1 << endl; 
  
  Interval somme2(0,0);
  for( int k=max; k>=1; --k ) somme2+= 1 / sqr( Interval(k) );
  cout << "Sommation par indices dcroissants : " << somme2 << endl; 
  
  cout << "\nLes deux encadrements sont corrects," << endl 
       << "mais l'un est plus fin que l'autre !" << endl
       << "Comment expliquer ce phnomne ?\n" << endl;
}
