//=======================================================================
// somme-naive.cc : sommation de la srie  terme gnral 1/k
// Copyright (C) 2004-2007 Michael Eisermann, all rights reserved
// Institut Fourier, Universit Joseph Fourier, Grenoble, France
//
// Description :
// Ce petit programme calcule naivement la somme de 1/k pour k=1,...,n 
// puis dans le sens inverse k=n,...,1.  Les deux rsultats diffrent !
// Exercice : expliquer la diffrence, et essayer de condlure.
//
// Commentaire :
// Vous trouvez le mme calcul mais plus fiable dans les fichiers 
// somme-interval.cc  et  somme-rreal.cc .  La programmation est 
// lgrement plus complexe, mais le rsultat et plus informatif !
//=======================================================================

#include <iostream>
using namespace std;

template <typename Flo>
void sommation( const int max )
{
  Flo somme1= 0;
  for( int k=1; k<=max; ++k ) somme1+= Flo(1) / Flo(k) / Flo(k);
  cout << "sommation par indices croissants   : " << somme1 << endl;

  Flo somme2= 0;
  for( int k=max; k>=1; --k ) somme2+= Flo(1) / Flo(k) / Flo(k);
  cout << "sommation par indices dcroissants : " << somme2 << endl;
}

int main()
{
  const int max= 10000;
  cout.precision( 21 );
  cout << "\nBonjour et bienvenue ! Je calcule la somme s des termes 1/k^2" << endl
       << "pour k de 1  " << max << " dans le sens croissant puis dcroissant en k." << endl;

  cout << "\nCalcul avec le type float (24 bits =>  peu prs 7 dcimales) :" << endl;
  // cout.precision( 9 );
  sommation<float>( max );
  
  cout << "\nCalcul avec le type double (53 bits =>  peu prs 16 dcimales) :" << endl;
  // cout.precision( 18 );
  sommation<double>( max );
  
  cout << "\nCalcul avec le type long double (64 bits =>  peu prs 20 dcimales) :" << endl;
  // cout.precision( 22 );
  sommation<long double>( max );
  
  cout << "\nOn constate que les rsultats diffrent !" << endl 
       << "Comment expliquer ce phnomne trange ?" << endl
       << "Que peut-on dduire pour le rsultat exact ?" << endl
       << "( comparer avec le programme somme-interval.cc)\n" << endl;
}
